
/* Chrysalide - Outil d'analyse de fichiers binaires
 * comp.h - prototypes pour la représentation des comparaisons
 *
 * Copyright (C) 2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_COMP_H
#define _DECOMP_EXPR_COMP_H


#include <glib-object.h>


#include "../expression.h"
#include "../output.h"



#define G_TYPE_COMP_EXPRESSION               g_comp_expression_get_type()
#define G_COMP_EXPRESSION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_comp_expression_get_type(), GCompExpression))
#define G_IS_COMP_EXPRESSION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_comp_expression_get_type()))
#define G_COMP_EXPRESSION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_COMP_EXPRESSION, GCompExpressionClass))
#define G_IS_COMP_EXPRESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_COMP_EXPRESSION))
#define G_COMP_EXPRESSION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_COMP_EXPRESSION, GCompExpressionClass))



/* Définition d'une comparaison binaire quelconque (instance) */
typedef struct _GCompExpression GCompExpression;

/* Définition d'une comparaison binaire quelconque (classe) */
typedef struct _GCompExpressionClass GCompExpressionClass;


/* Indique le type défini pour une comparaison binaire quelconque. */
GType g_comp_expression_get_type(void);

/* Exprime une comparaison binaire quelconque. */
GDecExpression *g_comp_expression_new(GDecExpression *, CompSignType, GDecExpression *);



#endif  /* _DECOMP_EXPR_COMP_H */
